# WinStd: winstd::bstr Class Reference

Loading...
Searching...
No Matches
winstd::bstr Class Reference
COM Object Management

BSTR string wrapper. More...

`#include <WinStd/COM.h>`

Inheritance diagram for winstd::bstr:

## Public Member Functions

| bstr (LPCOLESTR src)
| Constructs BSTR from OLE string.
| bstr (LPCOLESTR src, UINT len)
| Constructs BSTR from OLE string with length.
template<class _Traits , class _Ax >
| bstr (const std::basic_string< OLECHAR, _Traits, _Ax > &src)
| Constructs BSTR from std::basic_string.
virtual | ~bstr ()
| Destroys the string.
UINT | length () const noexcept
| Returns the length of the string.
Public Member Functions inherited from winstd::dplhandle< BSTR, NULL >
| dplhandle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| dplhandle (handle_type h) noexcept
| Initializes a new class instance with an already available object handle.
| dplhandle (const dplhandle< handle_type, INVAL > &h)
| Copy constructor.
| dplhandle (dplhandle< handle_type, INVAL > &&h) noexcept
| Move constructor.
dplhandle< handle_type, INVAL > & | operator= (handle_type h) noexcept
| Attaches already available object handle.
dplhandle< handle_type, INVAL > & | operator= (const dplhandle< handle_type, INVAL > &h) noexcept
| Duplicates the object.
dplhandle< handle_type, INVAL > & | operator= (dplhandle< handle_type, INVAL > &&h) noexcept
| Moves the object.
handle_type | duplicate () const
| Duplicates and returns a new object handle.
void | attach_duplicated (handle_type h)
| Duplicates an object handle and sets a new object handle.
Public Member Functions inherited from winstd::handle< BSTR, INVAL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (handle_type h) noexcept
| Initializes a new class instance with an already available object handle.
| handle (handle< handle_type, INVAL > &&h) noexcept
| Move constructor.
handle< handle_type, INVAL > & | operator= (handle_type h) noexcept
| Attaches already available object handle.
handle< handle_type, INVAL > & | operator= (handle< handle_type, INVAL > &&h) noexcept
| Move assignment.
| operator handle_type () const
| Auto-typecasting operator.
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.).
handle_type * | operator& ()
| Returns the object handle reference.
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct.
bool | operator! () const
| Tests if the object handle is invalid.
bool | operator< (handle_type h) const
| Is handle less than?
bool | operator<= (handle_type h) const
| Is handle less than or equal to?
bool | operator>= (handle_type h) const
| Is handle greater than or equal to?
bool | operator> (handle_type h) const
| Is handle greater than?
bool | operator!= (handle_type h) const
| Is handle not equal to?
bool | operator== (handle_type h) const
| Is handle equal to?
void | attach (handle_type h) noexcept
| Sets a new object handle for the class.
handle_type | detach ()
| Dismisses the object handle from this class.
void | free ()
| Destroys the object.

## Protected Member Functions

void | free_internal () noexcept override
| Destroys the string.
handle_type | duplicate_internal (handle_type h) const override
| Duplicates the string.
Protected Member Functions inherited from winstd::dplhandle< BSTR, NULL >
Protected Member Functions inherited from winstd::handle< BSTR, INVAL >

## Additional Inherited Members

Public Types inherited from winstd::handle< BSTR, INVAL >
typedef BSTR | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< BSTR, INVAL >
static const BSTR | invalid
| Invalid handle value.
Protected Attributes inherited from winstd::handle< BSTR, INVAL >
handle_type | m_h
| Object handle.

## Detailed Description

BSTR string wrapper.

## Constructor & Destructor Documentation

## ~bstr()

virtual winstd::bstr::~bstr | ( |  | ) |

inlinevirtual

Destroys the string.

See also
  SysFreeString function

## Member Function Documentation

## duplicate_internal()

handle_type winstd::bstr::duplicate_internal | ( | handle_type | h | ) | const

inlineoverrideprotectedvirtual

Duplicates the string.

Parameters

  [in] | h | Existing string

Returns
  Duplicated string

See also
  SysAllocString function

Implements winstd::dplhandle< BSTR, NULL >.

## free_internal()

void winstd::bstr::free_internal | ( |  | ) |

inlineoverrideprotectedvirtualnoexcept

Destroys the string.

See also
  SysFreeString function

Implements winstd::handle< BSTR, INVAL >.

## length()

UINT winstd::bstr::length | ( |  | ) | const

inlinenoexcept

Returns the length of the string.

See also
  SysStringLen function

The documentation for this class was generated from the following file:

- include/WinStd/COM.h